

;****************************************
;Fusion/ZM style chain block PLM
;By: Black Falcon
;Version: 1.00

;This PLM defines the starting block of a chain of blocks to break
;Place it on a breakable block of any sort. Destroying that one block triggers the breaking of the chain.

;NOTE: it will NOT be triggered if any other block of the chain you defined gets destroyed!
;NOTE2: it will destroy ANY PLM within its path, except for this PLM itself, which will be triggered in this case.
;NOTE3: The broken chain will return after re-entering the room.

;So be careful when laying out the chain's path so it doesn't destroy items 'n stuff!
;You can trigger multiple chains by putting another chainblock PLM within the current chain's path
;this way you can make the chain branch off into different directions

;further instructions are given in the PLM's text file
;if you don't see the PLM in SMILE, yet, make sure to download it here:
;https://dl.dropboxusercontent.com/u/18141148/website/ASM/Chainblocks.zip
;file contains everything you need to set it up properly


;----------------------------------------
;----------------------------------------



	;!blockindex = $1D77,x					;variable use PLM value
lorom

org $84F060	

DW INIT : DW INST

INST:
DW MAIN						;If this spot is used in your ROM, just change it to some section that is unused in bank 84.
											;Make sure to change the name of the PLM's graphic and text file in SMILE's PLM directory!!
print " INIT code ", pc											
INIT:						
PHX                     
 LDA $1C87,y 
 LSR A                   
 STA $1D77,y
 TYX                     
 LDA #$0001              
STA $7EDE1C,x
 PLX 
RTS      

MAIN:              
 PHY                     
 PHX   
 JSR RUN 
 PLX                     
 PLY                     
 PLA                     
 RTS  
 
print " Run code ", pc
 RUN:
 TXY                     
LDA #INST            
 STA $1D27,x
 PHX                     
 LDX $1C87,y
LDA $7F0002,x
 PLX                     
CMP #$FF00              
 BEQ BREAK   
 AND #$F000              
 CMP #$4000              
 BEQ IDLE 
 CMP #$7000              
BEQ IDLE   
 CMP #$8000              
 BEQ IDLE   
 CMP #$B000              
 BEQ IDLE    
 CMP #$C000              
BEQ IDLE   
CMP #$F000              
 BEQ IDLE    
CMP #$A000              
 BEQ IDLE   
 BRA BREAK

IDLE:
LDA #$0001              
STA $7EDE1C,x
RTS      

print " BREAK ", pc
BREAK:
 LDA $1DC7,x
 AND #$00FF              
 BEQ $47   
 TAY                     
 LDA $1D77,x
STA $0DC4 
LDA #$D074              
 JSL $8484E7
 DEY                     
 TYA                     
 STA $12   
 LDA $1DC7,x
 AND #$FF00              
 CLC                     
 ADC $12    
STA $1DC7,x
 LDA #$0004              
STA $7EDE1C,x
 LDA $1DC7,x
 AND #$0F00              
BEQ $1A   
 XBA                     
 CMP #$0005              
 BCS $14   
 CMP #$0001              
BEQ $1D    
 CMP #$0002              
BEQ $1D    
 CMP #$0003              
BEQ $1D    
 CMP #$0004              
 BEQ $24    
LDA #$DFA9              
 STA $1D27,x
 LDA #$0001              
STA $7EDE1C,x
 RTS                     
 INC $1D77,x  
 BRA $1B    
 DEC $1D77,x
 BRA $16    
 LDA $1D77,x
 SEC                     
 SBC $07A5  
 STA $1D77,x
 BRA $0A    
 LDA $1D77,x  
 CLC                     
ADC $07A5  
 STA $1D77,x   
 PHX                     
 LDA $1D77,x  
 TAX                     
LDA $7F6402,x
 AND #$00FF              
 BEQ $16    
 CMP #$0005              
 BCS $11    
 XBA                     
 PLX                     
 STA $12   
 LDA $1DC7,x  
 AND #$00FF              
 CLC                     
 ADC $12    
STA $1DC7,x
 RTS                     
 PLX                     
 RTS                                        
	