lorom

;;;;;;;;;;;;;;;; PLM by Benox50 ;;;;;;;;;;;;;;;;;

;;;;;; INFO:
; Create a trigger object using PLM, run any code once the player touch this to create scripting events within rooms
; Extend trigger zone with copy blocks
; ***This create the trigger object but youll need asm knowledge to create your own code
; Add the PLM files for either Smile or Smart in their respective spot, follow folder architecture
; Sorry, didnt bother to XML for Smart, but should be simple

; Low byte = Instruction list index (which script you wanna run, start at 0)

{
;;;;;;;;;;;;;;;;;;;;;;;;
;;; Collision touch trigger type
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; PLMs entries for block collision reaction - special ( special air, special solid...) ;
org $9491D7
	DW #BTS_PLM_Trig

; Trigger PLM
org $84F013
	DW #PLM_Trig_Init, #PLM_GenDel_Inst

;;; Trigger PLM, BTS trigger
org $84B663
BTS_PLM_Trig:
	DW #PLM_TrigBTS_Init, #PLM_GenDel_Inst

;Unused
;org $84B667
;Unused
;org $84B66B
;Unused
;org $84B66F









; FREE SPACE ;  Might collide, even with my own asm, so change this
org $84F030






;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;; Trigger PLM ;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
{
;;; MAIN ;;;
{
; Trigger PLM Initiation, Create custom block collision reaction (player trigger)
PLM_Trig_Init:
	LDX $1C87,y : LDA #$304F : JSR $82B4 ;Block 3 (special air) BTS 4F
	RTS

; PLM spawn by BTS touch Initiation, get the trigger PLM data from here
PLM_TrigBTS_Init:
	PHX
	JSR PLM_BTS_Search : BCC + ;Get PLM index in [X] to access its data
	LDA $1DC7,x : AND #$00FF : ASL : TAX ;Get low byte PLM setting as index
	LDA.w PLM_Trig_Arr,x : STA $1D27,y ;Set instruction list pointer
+
	PLX : RTS

;;;; Instruction list array ;;; (The Low byte of PLM will index this list)
;This is where you add your scripted behaviors, you select which one to use by setting the low byte in the trigger PLM
PLM_Trig_Arr:
	DW #PLM_TrigBTS_InstA, #PLM_TrigBTS_InstB, #PLM_TrigBTS_InstC ; ...
}




;;; Triggered instructions (scripts to run when samus touch trigger) ;;;
{
;Script 1 (example, can delete and put your owns)
; GT camera, set cmaera scrolling to center for second phase
PLM_TrigBTS_InstA:
	DW #PLM_Build_GT
	DW $86BC ;Delete
; Set camera scrolling to center for second phase
PLM_Build_GT:
	LDA #$0004 : STA $0941
	RTS

;Script 2
PLM_TrigBTS_InstB:
; add ᶜᵒᵈᵉ here (PLM instruction list)

;Script 3
PLM_TrigBTS_InstC:
; add ᶜᵒᵈᵉ here (PLM instruction list)
}




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; PLM Generic functions ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
{
;Generic delete instruction list
PLM_GenDel_Inst:
	DW $86BC ;Delete PLM, (code prolly is in Init.)



; Search PLM from BTS touch by match nth block of room
PLM_BTS_Search:
print " PLM_Event (Touch Event): ", pc
	LDX #$0050
-
;Get Event PLM index with search by match nth block of room (cause both same spot)
	DEX #2 : BMI +
	LDA $1C87,x : CMP $1C87,y : BNE -
	SEC : RTS
+
	CLC : RTS
}

}

