;Instant_Pickups	v1.20
;--------------------------------
;Removes item fanfare from PLMs and flashes the item name on the HUD
;--------------------------------

!freeram = $0B0C	;Unused RAM, high byte is used to store the message to flash, low byte is the timer.
!charcount = #$0007	;The number of characters in each message. You could increase this to #$0009 if your hack doesn't use reserve tanks, or more than that if you made the ammo icons smaller.	
!charcount2 = #$000E	;The number of characters in each message, times two for indexing purposes. 
!flashtime = #$0078	;Number of frames to flash the message for.

;--------------------------------
!A = $E0
!B = $E1
!C = $E2
!D = $E3
!E = $E4
!F = $E5
!G = $E6
!H = $E7
!I = $E8
!J = $E9
!K = $EA
!L = $EB
!M = $EC
!N = $ED
!O = $EE
!P = $EF
!Q = $F0
!R = $F1
!S = $F2
!T = $F3
!U = $F4
!V = $F5
!W = $F6
!X = $F7
!Y = $F8
!Z = $F9
!SB = $4E ;this is for a space/blank tile

;-----------------Custom Instruction----------------------------
lorom

org $8488B0
	INCBIN pickuproutines.bin	;NOP's out the native message routine from pickups
org $84E099
	INCBIN instructionlists.bin	;Gives item pickups the new HUD message instruction


org $84F060	;Freespace in $84

PHX  

LDA #$0000 : TAX						;setup A and X to #$0000
LDA #$000D : JSL $809139					;Play clack sound effect. If you want different pickups to have different sounds, 
								;the best way to do that would be to make a copy of this instruction somewhere in freespace, 
								;and have the different-sounding PLMs use that.
LDA $0000, y : AND #$00FF : XBA : ADC !flashtime : STA !freeram	;\
								;/Retrieves what message to flash from PLM instruction. Lives in high byte of timer.
PLX 
INY
RTS

;------------------Display PLM Message-------------------------
org $828957

JSR $F720		;let's hi-jack the main game loop...


org $82F720		;Freespace in $82

STZ $0590		;original code replaced by JSR
LDA !freeram : AND #$00FF : BEQ QUIT


	PHX : PHY


	LDA #$0000 : TAX : TAY
	LDA !freeram : AND #$FF00 : XBA : JSR MULTBY7 : TAY	;Get message location
	-							;\
	LDA $F800,y : AND #$00FF : JSR PALCOL : STA $7EC60A,x	;|-Print characters to screen
	INY : INX : INX						;|
	CPX !charcount2 : BMI -					;/



	PLX : PLY




DEC !freeram
LDA !freeram : AND #$00FF : BEQ RESET
RTS

;-------------------cleanup HUD from here---------------------
RESET:
PHX
LDX #$0000
-				;\
LDA #$2C0F : STA $7EC60A,x	;|-Loop through all indices and turn them black
INX : INX			;|
CPX !charcount2 : BMI - 	;/
PLX

QUIT:
STZ !freeram
RTS

;--------------------SubRoutines Below------------------------
MULTBY7:					;\
BEQ +		;handle if the index is 0	;|
						;|-Multiply by 7 to get the base message
	PHX : TAX : LDA #$0000			;| index, which is then added to in the
	-					;| dislay loop to get each character.
	CLC					;| 
	ADC !charcount				;|
	DEX : CPX #$0000 : BNE -		;|
						;|
	PLX					;/

+
RTS

;----------

PALCOL:
PHA

LDA !freeram : AND #$0004 : BEQ +	;If the fours bit is on, add 08 to the 
					;high bytes of the character. Change the BEQ
	PLA : CLC : ADC #$0800 : RTS	;to a BRA if you don't want the message to flash.
+
PLA : CLC : ADC #$1C00			;else, add 1C to make it yellow
RTS

;--------------------List of Messages--------------------------

org $82F800 ;Zero indexed. PLM messages are listed in order of PLM entry. They go up to message #$0014.

db !E, !N, !E, !R, !G, !Y, !SB
db !M, !I, !S, !S, !I, !L, !E
db !S, !U, !P, !E, !R, !S, !SB
db !P, !B, !S, !SB, !SB, !SB, !SB
db !B, !O, !M, !B, !SB, !SB, !SB
db !C, !H, !A, !R, !G, !E, !SB
db !I, !C, !E, !SB, !SB, !SB, !SB
db !H, !I, !SB, !J, !U, !M, !P
db !S, !P, !E, !E, !D, !SB, !SB
db !W, !A, !V, !E, !SB, !SB, !SB
db !S, !P, !A, !Z, !E, !R, !SB
db !S, !P, !R, !I, !N, !G, !SB
db !V, !A, !R, !I, !A, !SB, !SB
db !G, !R, !A, !V, !I, !T, !Y
db !X, !R, !A, !Y, !SB, !SB, !SB
db !P, !L, !A, !S, !M, !A, !SB
db !G, !R, !A, !P, !P, !L, !E
db !S, !P, !SB, !J, !U, !M, !P
db !S, !C, !R, !E, !W, !SB, !SB
db !M, !O, !R, !P, !H, !SB, !SB
db !R, !E, !S, !E, !R, !V, !E


;--------------------------Stack Energy Tanks----------------------------

org $809BD3	;hijack energy drawing loop

JSR $DA00
NOP #9



org $80DA00	;free space in $80


CPY #$000E : BPL +	;\-Checks the current index in the draw loop.
LDX #$3430		;|
LDA $14			;|-If drawing the 7th or below e tank, use normal graphics.
BEQ ++			;|
DEC $14			;|
LDX #$2831		;|
++			;|
RTS			;/

+			;\
LDX #$2831		;|
LDA $14			;|-If drawing the 8th or above, use blue for full and pink for empty tank.
BEQ +			;|
DEC $14			;|
LDX #$2C31		;|
RTS			;|
+			;|
RTS			;/

HEALTH_CHECK_ROW2:
LDA $09C2 : CMP #$0320 : BPL +	;Switch how many tanks to draw based on Samus's health.
CPY #$000E : RTS
+
CPY #$001C : RTS

org $809BE9
JSR HEALTH_CHECK_ROW2	;stop drawing e tanks after finishing the first row.

org $809CDC		;change the draw location so the top row overlaps the bottom one.
dw $0042, $0044, $0046, $0048, $004A, $004C, $004E



