;Lore_Pickups.asm
;-----------------------------
;On touch: Shows the map for a specified area index.
;To use it: 
;+Put a shot block reserve tank ($EE0D) in the room. 
;+Item ID = area index of desired map.
;$0000 = Crateria
;$0001 = Brinstar
;$0002 = Norfair.... etc. 

lorom

org $899100	;Change this to whatever gfx you want to use.
	INCBIN loregfx1.bin	;If working with SMART, you will probably have to replace it with the file path of the .bin relative SMART's xkas.

;-------------------Normal Version $EE0D----------------------
org $84EE0D	;Replaces shot block reserve tank instruction list

;dw $8764, $9100 : db $00, $00, $00, $00, $02, $02, $02, $02	;GFX instruction for loregfx4, Prime Scan
;dw $8764, $9100 : db $00, $00, $00, $00, $01, $01, $01, $01	;GFX instruction for loregfx3, book
;dw $8764, $9100 : db $00, $00, $00, $00, $01, $01, $01, $01	;GFX instruction for loregfx2, notepad
dw $8764, $9100 : db $01, $01, $01, $01, $01, $01, $01, $01		;GFX instruction for loregfx1, paper
;Each of the instructions above are the same but with different palettes^
;Uncomment the one that matches the gfx you're using
RETURN:
dw $8A24, ONTOUCH	;pointer to instructions to run on touch
dw $86C1, $DF89		;Same for all item PLMs		

LOOP_ANIMATION:
dw $E04F, $E067	
dw $8724, LOOP_ANIMATION	
												
ONTOUCH:
dw LOREPAUSE	;Init. pause fade-in
dw $000C, $9497	;frame delay, draw air
dw LOREPAUSE2	;Switch out map

WAITPAUSE:
dw $0001, $9497	;Draw air each frame to avoid infinite loop
dw RESTOREMAP, WAITPAUSE	;restore the map when unpausing
EMPTY_ITEM:
dw $00FF, DRAW_TOUCH
dw $8724, RETURN		;respawn the item



org $84F020	;freespace for instructions
LOREPAUSE:
PHY : PHX
LDA #$000C : STA $0998	;change game state to pause
PLX : PLY
RTS

LOREPAUSE2:
PHY : PHX

PHY : PHX
JSL $8085C6	;save current explored map data
PLX : PLY

LDX $1C27 : LDA $079F : STA $1E17,x ;Store current area index in PLM var

LDA $1DC7,x : STA $079F	;change area index to the one specified in the PLM arg, changes map shown
LDY #$00FE : LDA #$FFFF : LDX #$07F7	;\
JSL $8083F6                             ;|-Set the entire map as being explored
PLX : PLY
RTS

RESTOREMAP:
;Put the map exactly like it was before the pickup
LDA $0998 : CMP #$0012 : BEQ +	;\
	LDA $0000,y : TAY : RTS 	;|-Wait until game state #$0012 of unpausing; if not #$0012 then go to instruction argument.
+								;/
LDX $1C27 
LDA $1E17,x : STA $079F			;Put the area index back
STZ $1D77,x	;un-trigger item collision
INY : INY

PHY : PHX
JSL $80858C	;Load explored map data
PLX : PLY
RTS

DRAW_TOUCH:	;Draw instruction while waiting to respawn
DW $0001, $0075, $0000


;Some things in $82 for handling the map when opened like this.
org $82B9C8	;Check to draw Samus position or not
JMP INDICATOR_CHECK

org $82F70F	;free space in $82
INDICATOR_CHECK:
LDA $08F4 : AND #$00F0 : CMP #$00F0 : BEQ +
	LDA #$0E00
	JMP $B9CB	;if final map tile explored then skip samus indicator, else draw it.
+
;Then position the map once on startup
LDA $08F4 : BIT #$000F : BEQ +
AND #$00F0 : STA $08F4
LDA #$0080 : STA $B1	;map x
LDA #$FFC8 : STA $B3	;map y
+
;Move the map x line out here if you want to lock the x position
JMP $B9FB	;Don't draw it if check succeeded
