;----------------Event Check Tiles-----------------
;--------------Potential Event Tracker-------------
;----------------OmegaDragnet9---------------------


;Takes a bit of user input.
;Depending on whether a particular event is set or not,
;this PLM will display one of two air tiles.
;The two you display is 100% dependent on what you choose from the Tilemap.
;I advise rearranging CRE, and picking two blocks from that.

;Potential use cases:
;Replicate the beacon system from Phazon Hack (rooms that indicated where the particles were located.)
;Having a room like this would allow the player to track what events they have already set 
;(Plays into the Artififact PLM concept I've been exploring.)

;Other use case could be more cryptic, for puzzles. 

lorom

org $84FD20

dw Setup
dw InstList 

Setup:  

PHY
LDY $1C27		;PLM index
LDA $1DC7,y		;PLM variable (event # to set)
AND #$00FF
PLY
JSL $808233		;Check against Event A
BCC +

; Make PLM block air if Event A is already Set
LDX $1C87,y
LDA #$00F6		;Loads Tile in Tilemap. 
STA $7F0002,x

RTS

; Normal PLM Preinstruction
+
LDX $1C87,y
LDA #$00F7		;Loads Tile in Tilemap. 
STA $7F0002,x

RTS

InstList:

DW $86B4
;DW $86BC