lorom

;-----------------------------Shotblock Event PLM v 1.4---------------------------------------------------
;-----------------------Use to Set Event by a Shot Reaction-----------------------------------------
;-------------------Intended to make permanently-gone Blockades-------------------------------------

;---------------------------------------------------------------------------------------------------

;Use the low byte of the PLM to set the Event.
;Use the high byte to determine which shotblock reaction to use. 
;Place the PLM inside a section of corresponding BTS Blocks.
;Just like BTS blocks, the PLM will not have any GFX 
;but will delete any GFX it is placed under when destroyed. 

;Does not appear under X-Ray.

;Known Bug:
;Must be placed 4 tiles horizontally far from a door tile.
;Must be placed 3 tiles vertically beyond a vertical door tile. 

;If you don't abide by this, the old GFX will load until you walk off-screen. 

;---------------------------------------------------------------------------------------------------

;Credits to Tundain's Gate Locking System PLMs, this was studied to get the right Setup ASM for the PLM.
;Thanks to PJ.Boy for the Bank logs
;Thanks to dewhi100, Benox50, MetroidNerd#9001, Amoeba, Test Runner and JAM.
;All of their resources helped me to understand Event ASM better.

;Thanks to Amoeba, TestRunner, and Oi27. Was experimenting with the idea of using Events independent of room states
;and today's discussion on Discord set me in the right direction. 

;-------------------------------Defines-------------------------------------------------------------

!84Freespace = $84F7C0
	
;---------------------------Power Bomb Event PLM----------------------------------------------------

org !84Freespace

dw Setup
dw InstList 

Setup:  

PHY
LDY $1C27		;PLM index
LDA $1DC7,y		;PLM variable (event # to set)
AND #$00FF
PLY
JSL $808233		;Check against Event A
BCC +

; Make PLM block air if Event A is already Set
LDX $1C87,y
LDA #$00FF		;Loads Tile in Tilemap, beware of this if you are using cutsom CRE.  
STA $7F0002,x

RTS

; Normal PLM Preinstruction
+
LDX $1C87,y 			; PLM's location in the room (nth block * 2)
LDA #$C044 : JSR $82B4 
RTS


InstList:

DW $8A24,Event			; Link instruction = $D4E8
DW $86C1,ShotReaction 	; Pre-instruction = go to link instruction if shot 
DW $86B4				; Sleep

ShotReaction:

LDY $1C27				;PLM index
LDA $1DC7,y				;PLM variable (event # to set)
AND #$F000

CMP #$0000 : BEQ .Shot 
CMP #$1000 : BEQ .PowerBomb 
CMP #$2000 : BEQ .MissileShot 
CMP #$3000 : BEQ .SuperMissileShot 

RTS

.Shot
JSR $BD0F : RTS

.PowerBomb
JSR $BD26 : RTS

.MissileShot
JSR $BD50 : RTS

.SuperMissileShot
JSR $BD88 : RTS 


Event:

DW .EventInst 
DW $8724,$C9CF ;or $CBB7


.EventInst

PHY
LDY $1C27		;PLM index
LDA $1DC7,y		;PLM variable (event # to set)
AND #$00FF
PLY
JSL $8081FA		;Set event A
RTS

;---------------------------

;org $84CE2B	;Hijack

;JSR $F900	;Freespace

;org $84F900	;Freespace

;STA $1E17,y
;AND #$0FFF             ;\
;STA $7F0002,x ;} PLM block = 00B6h
;CLC


;LDA $079D			;Excellent script from MetroidNerd#9001
;JSL $808233
;BCS +
;LDA $079D
;JSL $8081FA
;LDA #$0006			;Optional earthquake
;STA $183E
;LDA #$0046 
;STA $1840
;LDA #$0046
;JSL $8090CB
;+
;RTS

;RTS

