lorom

;CUSTOM CUTSCENES by Tundain

;make sure to credit please!


;How to use: place trigger plm in room where cutscene starts, make sure there are door blocks to the cutscene room, on the correct screen edge
;in the cutscene room, place cutscene room plm, place door blocks on correct screen edge
;"correct screen edge" here refers to the corresponding edge for the direction of your door (if in your trigger room, the door exits to the left, place the door tiles on a left edge)
;make sure the player can't reach the door blocks normally

; trigger plm parameters:
;XCII

;X = 0 means regular cutscene
;X = 8 means it's a demo cutscene
;C = trigger condition
;II = cutscene index 

; trigger conditions
; 0 = first enemy in list has been killed
; 1 = needed amount of enemies has been killed
; 2 = samus has touched plm area
; 3 = area main boss/ mini boss/ torizo is dead
; 4 = item has been collected

;If option 3 is selected, then X determines what exactly should be dead
;(X = 1 means main boss, X = 2 means mini boss, X = 4 means torizo)

; cutscene plm parameters:
;XCII

;X = 0 means regular cutscene
;X = 1 means it's a demo cutscene
;C = scrolling mode (only used if X = 0)
;II = cutscene index 

; scrolling modes
; 0 = no scrolling
; 1 = vertical scrolling
; 2 = horizontal scrolling
; 3 = diagonal scrolling

;THINGS TO NOTE:
;-make sure the trigger and cutscene rooms have appropriate door tiles to the corresponding rooms (make sure the scrolls thay are in aren't red)
;-if item collected condition is chosen, then x coordinate of plm is used as index for the item bit to check 
;(this means that if plm x block = $10, then item to check will be xray, and if x block = $05, then check for gravitiy suit)
;-the doors you use to transition from the origin room and back still need to follow the rules of regular door transitions
;(they need to be against a screen edge or a red scroll, and the screen where you end up needs to be against a screen edge or red scroll 
;(so if you wanna set to the middle of a room, use door asm to set a red scroll behind where the door comes from))
;-after the cutscene has played, the PLMs set an event bit so the cutscene only plays once, the event bit in question is determined by the plm's y coordinate
; (so if your plm's y position is $08, it will set event $08)
; Now! if you're using position as your trigger condition, this means that the plm's y position matters for both the event bit and as the trigger 
;(since you need to place the plm at the location to trigger), so watch out with that
;If selecting "main boss/mini boss/torizo is dead" then be wary that you shouldn't place the plm in the same room as the boss, as this means the player won't be able to collect the item drops
; instead, place the plm in a neighbouring room where the player will pass after killing the boss

;This patch uses a lot of unused RAM:
; $07ED - used as cutscen flag
;all the below- used as mirrors of samus's current equipment
; $07D3
; $07D5
; $07D7
; $07D9
; $1886
; $1888
; $188A 
; $188C
; $188E 
; $1890
; $1892 
; $1894 
; $1896
; $186C 

;check to make sure no other patches you may have applies are using this RAM as well, and if so change the defines below to a different address of unused RAM
;in order to find unused RAM addresses, go to https://patrickjohnston.org/ASM/Lists/Super%20Metroid/RAM%20map.asm and search for addresses where it says "unused"

;-demo cutscenes only need a returning door
;-set the demo cutscene timer to a bit longer than the actual demo timer (otherwise some of the demo inputs will persist when going back)


;info on how to setup cutscene entries entry below 
;when adding a new entry, make sure to add it's name to the "scene params" list, it's position in the list is then used as the cutscene index 
;(starting from 0, so if you make a new cutscene, and it becomes the 5th entry in the list below, use index $04 in the plm argument)

;----User defines---------
;repoint these to any freespace in the corresponding banks
!Bank84freespace = $84EFF0
!Bank82freespace = $82F710
!Textfreespace = $AEFD20

!Cutsceneflag = $07ED
!EquippedItemsmirror = $07D3
!CollectedItemsmirror = $07D5
!EquippedBeamsmirror = $07D7
!CollectedBeamsmirror = $07D9
!Energymirror = $1886
!Maxenergymirror = $1888
!Missilesmirror = $188A
!Maxmissilesmirror = $188C
!Supermissilesmirror = $188E
!Maxsupermissilesmirror = $1890
!Powerbombsmirror = $1892
!Maxpowerbombsmirror = $1894
!Maxreserveenergymirror = $1896
!Reserveenergymirror = $186C


;-----Code defines-----------
!Triggerxpos = $0000,y
!Triggerypos = $0002,y
!Cutsceneduration = $0004,y
!ReturnTriggerxpos = $0006,y
!ReturnTriggerypos = $0008,y
!Returnxpos = $000A,x
!Returnypos = $000C,x
!Scrolltimer = $000E,y
!Scrollspeed = $0010,y
!Scrollsubspeed = $0012,y
!Extrascrollspeed = $0014,y
!Extrascrollsubspeed = $0016,y

!DemoIndex = $0000,y
!DemoReturnTriggerxpos = $0002,y
!DemoReturnTriggerypos = $0004,y
!Demotimer = $0006,y
!DemoReturnxpos = $0008,x
!DemoReturnypos = $000A,x


!PlmArgY = $1DC7,y
!PlmArgX = $1DC7,x
!ScenepointerY = $1E17,y
!ScenepointerX = $1E17,x
!PlmPreInstY = $1CD7,y
!PlmPreInstX = $1CD7,x

!Samusxpos = $0AF6
!Samusypos = $0AFA


;---Plm entries-----
org !Bank84freespace
print "trigger plm: ",pc
DW setup,instlist

print "cutscene room plm: ",pc
DW init,cutscenInst

Sceneparams: ; this is the list with all the cutscene entries, make sure to expand it properly
DW Ridleydead,draygondead,speedbooster

;---------------------------------------------------------------------------------------------------
;---------------------------------------------------------------------------------------------------
;Cutscene entry format:

;  Tx Ty Ct RTx RTy Rx Ry ScT Sp SbSp ExSp ExSbSp

;Tx : Trigger x = x position to put samus where the door tiles are

;Ty : Trigger y = y position to put samus where the door tiles are

;Ct : cutscene timer = how long the cutscene lasts

;RTx : Return trigger x = x position to put samus where the door tiles are when returning

;RTy : Return trigger y = y position to put samus where the door tiles are when returning

;Rx : return x = x position to place samus when she comes back into the room

;Ry : return y = y position to place samus when she comes back into the room

;ScT : scroll timer (optional) = how long should the screen be scrolling

;Sp : speed (optional) if scrolling cutscene, use this as speed

;SbSp : subspeed (optional) if scrolling, use this as subspeed

;ExSp = extra speed (optional) if scrolling diagonally, use this as horizontal speed

;ExSbSp = extra subspeed (optional) if scrolling diagonally, use this as horizontal subspeed

;---------------------------------------------------------------------------------------------------
;---------------------------------------------------------------------------------------------------

;Demo cutscene entry format:

;DeID RTx RTy DT Rx Ry 

;DeID : demo id = which demo to play 

;RTx : Return trigger x = x position to put samus where the door tiles are when returning

;RTy : Return trigger y = y position to put samus where the door tiles are when returning

;DT : demo timer = how long until we send samus back

;Rx : return x = x position to place samus when she comes back into the room

;Ry : return y = y position to place samus when she comes back into the room

;---------------------------------------------------------------------------------------------------
;---------------------------------------------------------------------------------------------------

;Important: like the examples below, each value is two bytes long

;these are all the entries themselves (the ones here are the ones used in the example patch)
Ridleydead:
DW $0008,$0080,$0180,$00F0,$0078,$0080,$0090
draygondead:
DW $0008,$0080,$01C0,$02F0,$0080,$0080,$0088,$0120,$FFFF,$1000
speedbooster:
DW $0000,$06F8,$0080,$0528,$0080,$0080

;----------------------------------------------------------------------------------
;****************----------Trigger & returning PLM --------------******************
;----------------------------------------------------------------------------------

setup:
TYX
JSL $848290 : LDA $1C2B : JSL $808233 : BCC + ; if cutscene event set, delete plm inmediately (uses plm Y block as event to check)
TYX : STZ $1C37,x : RTS
+:
JSR getpointer
LDA !Cutsceneflag : BNE handlereturning ; if cutscene flag set, take care of bringing samus back safely
LDA !PlmArgY : XBA : AND #$000F : ASL : TAX  : LDA conditions,x : STA !PlmPreInstY ;else, load trigger condition
CMP #position : BNE +
LDX $1C87,y
LDA #$3045 : JSR $82B4
+:
RTS

conditions:
DW enemy,enemies,position,boss,item

handlereturning:
JSR Loadfullmosaic
LDA #$0001 : JSL $90F084 : LDA #$000B : JSL $90F084 ;unlock samus and draw her again
LDX !ScenepointerY
LDA #holderplace : STA !PlmPreInstY
LDA !PlmArgY : BIT #$8000 : BNE resetdemo 
LDA !Returnxpos : STA !Samusxpos : LDA !Returnypos : STA !Samusypos ; set her return position
RTS

resetdemo:
LDA #$E913 : STA $0A60 ; remove demo input code
LDA !EquippedItemsmirror : STA $09A2 ;restore current equipment
LDA !CollectedItemsmirror : STA $09A4 
LDA !EquippedBeamsmirror : STA $09A6
LDA !CollectedBeamsmirror : STA $09A8
LDA !Energymirror : STA $09C2
LDA !Maxenergymirror : STA $09C4
LDA !Missilesmirror : STA $09C6
LDA !Maxmissilesmirror : STA $09C8
LDA !Supermissilesmirror : STA $09CA
LDA !Maxsupermissilesmirror : STA $09CC
LDA !Powerbombsmirror : STA $09CE
LDA !Maxpowerbombsmirror : STA $09D0
LDA !Maxreserveenergymirror : STA $09D4
LDA !Reserveenergymirror : STA $09D6
PHX 
LDX #$0000
LDA $7ED802,x : STA $09E4 ; restore moonwalk flag
LDX #$0014 
-:
LDA $7ED7C8,x : STA $09AA,x  ; reset controls bindings
DEX #2
BPL -
JSL $809A79 ; also re-initialise hud, so hud tilemaps get added back
PLX
LDA !DemoReturnxpos : STA !Samusxpos : LDA !DemoReturnypos : STA !Samusypos ; place samus back with demo params
RTS

holderplace:
LDA #fadeIn : STA !PlmPreInstX
RTS

fadeIn:
JSR FadeIn
BCC +
LDA $0CD0 : BEQ notcharge : LDA #$0041 : JSL $809021 ; if charging beam, resume playing sound
notcharge:
JSL $848290 : LDA $1C2B : JSL $8081FA ; set cutscene event bit as set, uses plm Y block as event to set
STZ !Cutsceneflag ; clear cutscene flag
STZ $1C37,x ;delete plm
RTS

enemy:
LDA $0F8C : BNE + ;check if first enemy hp = 0
BRA setupexit
+
RTS

enemies:
LDA $0E50 : CMP $0E52 : BNE + ; check if all enemies are dead
BRA setupexit
+:
RTS

position:
LDA $1D77,x : BEQ + ; check if triggered
BRA setupexit
+
RTS

boss:
LDA !PlmArgX : XBA : AND #$00F0 : LSR #4 : STA $12
PHX : LDX $079F : LDA $7ED828,x : PLX : AND $12 : BEQ + ;check if main boss/mini boss/torizo is dead
BRA setupexit
+
RTS

item:
JSL $848290 : PHX : ASL : TAX : LDA $81839F,x : STA $05E7 : PLX  : LDA $09A4 : BIT $05E7 : BEQ + ; check if collected item
BRA setupexit
+:
RTS

setupexit:
LDA #FadeOutstart : STA !PlmPreInstX
LDA #$0000 : JSL $90F084 ; lock samus
JMP Loadstartmosaic

FadeOutstart:
LDY !ScenepointerX
JSR FadeOut
BCC +
LDA !PlmArgX : BIT #$8000 : BEQ notdemo
JSR setmirrors
LDA !DemoIndex : STA $1F57; set which demo to play
notdemo: 
LDA #$0002 : JSL $80903F
LDA #$0001 : JSL $90F084 ; unlock samus for door transition
LDA #$000A : JSL $90F084 ; stop drawing samus
LDA !Triggerxpos : STA !Samusxpos
LDA !Triggerypos : STA !Samusypos ; place her on the door tiles
STZ $1C37,x
LDA #$0001 : STA !Cutsceneflag ; set cutscene flag
+
nothin:
RTS

setmirrors: ; loads mirrors of samus equipment and collection, to restore after demo is done (uses a lot of RAM sadge)
LDA #$0028 : STA $0998
LDA $09A2 : STA !EquippedItemsmirror
LDA $09A4 : STA !CollectedItemsmirror
LDA $09A6 : STA !EquippedBeamsmirror
LDA $09A8 : STA !CollectedBeamsmirror
LDA $09C2 : STA !Energymirror
LDA $09C4 : STA !Maxenergymirror
LDA $09C6 : STA !Missilesmirror
LDA $09C8 : STA !Maxmissilesmirror
LDA $09CA : STA !Supermissilesmirror
LDA $09CC : STA !Maxsupermissilesmirror
LDA $09CE : STA !Powerbombsmirror
LDA $09D0 : STA !Maxpowerbombsmirror
LDA $09D4 : STA !Maxreserveenergymirror
LDA $09D6 : STA !Reserveenergymirror
RTS
;----------------------------------------------------------------------------------
;****************----------Cutscene room PLM ----------------**********************
;----------------------------------------------------------------------------------


init:
LDA !Cutsceneflag : BNE + ; if no cutscene active, delete
TYX : STZ $1C37,x : RTS
+
JSR Loadfullmosaic
JSR getpointer : TAX
LDA !PlmArgY : BIT #$8000 : BNE +
LDA #$0000 : JSL $90F084 ; if regular cutscene, lock samus
+:
LDA #$0001 : STA $05F7; disable mini-map
LDA #placeholder : STA !PlmPreInstY
RTS


placeholder:; pre-inst gets executed once during room load, and constantly after vanilla fading, so a placeholder so fading only starts after vanilla fade

LDA #Fadein2 : STA !PlmPreInstX
RTS

Fadein2:
JSR FadeIn
BCC +
LDA !PlmArgX : BIT #$8000 : BNE Demoinstead
LDA !PlmArgX : XBA : AND #$000F : ASL : TAY : LDA cutscenemodes,y : STA !PlmPreInstX ; load cutscene settings
LDY !ScenepointerX
LDA !Scrolltimer : STA $7EDF0C,x
LDA !Cutsceneduration : STA $1D77,x
+:
RTS

Demoinstead: ; if demo, use demo timer parameter instead, and only that, since samus does stuff during a demo
LDY !ScenepointerX
LDA !Demotimer : STA $1D77,x
LDA #waiting : STA !PlmPreInstX
RTS

cutscenemodes:
DW waiting,verticalscroll,horizontalscroll,diagonalscroll

verticalscroll:
JSR waitscrolling
BCS waiting
LDY !ScenepointerX
verticalscrollskip:
LDA $0913 : CLC : ADC !Scrollsubspeed : STA $0913
LDA $0915 : ADC !Scrollspeed : STA $0915
BRA waiting

horizontalscroll:
JSR waitscrolling
BCS waiting
LDY !ScenepointerX
LDA $090F : CLC : ADC !Scrollsubspeed : STA $090F
LDA $0911 : ADC !Scrollspeed : STA $0911
BRA waiting


diagonalscroll:
JSR waitscrolling
BCS waiting ;if done scrolling, skip to waiting inmediately
LDY !ScenepointerX
LDA $090F : CLC : ADC !Extrascrollsubspeed : STA $090F
LDA $0911 : ADC !Extrascrollspeed : STA $0911
BRA verticalscrollskip ; execute vertical scrolling as well


waiting:
LDA $8F : BIT #$1000 : BEQ +
LDA #$0039 : JSL $80903F
BRA setupFadeOut
+: 
LDA $1D77,x : DEC : BEQ setupFadeOut ; if timer is up, start fading screen back out
STA $1D77,x
LDA #$0050 : STA $14 : LDA #$00D0 : STA $12 
PHB : PEA $B400 : PLB : PLB 
LDY #message : LDA #$0A00 : STA $16 : JSL $81879F
PLB
RTS


waitscrolling:; returns carry clear if not done scrolling, set otherwise
LDA $7EDF0C,x : BEQ setcarry
DEC : STA $7EDF0C,x
CLC : RTS
setcarry:
SEC : RTS

setupFadeOut:
LDA #$0001 : STA $1F53
LDA #FadeOutexit : STA !PlmPreInstX
JMP Loadstartmosaic

FadeOutexit:
JSR FadeOut
BCC + ; when done fadin, exit room
LDY !ScenepointerX
LDA !PlmArgX : BIT #$8000 : BNE exitdemo
LDA #$0004 : STA $18A8 ; set invincibility just in case there's an enemy
LDA #$0001 : JSL $90F084 ; unlock smaus for door transition
LDA !ReturnTriggerxpos : STA !Samusxpos
LDA !ReturnTriggerypos : STA !Samusypos ; set samus coords for door tiles
+:
RTS

exitdemo: ; if demo, use demo position parameters
LDA !DemoReturnTriggerxpos : STA !Samusxpos
LDA !DemoReturnTriggerypos : STA !Samusypos
RTS

getpointer: ; loads the pointer to the current cutscene in [A], but also stores it in $1D77 (PLM variable)
PHX
LDA !PlmArgY : AND #$00FF : ASL : TAX : LDA Sceneparams,x : STA !ScenepointerY
PLX
RTS

FadeOut: ; fades the screen out and increases mosaic effect, returns carry clear if still busy, carry set if done
PHP
LDA $0998 : CMP #$0008 : BNE carryclear ; game state check so this doesn't happen whilst pausing/unpausing
SEP #$20
LDA $57 : CMP #$FF : BEQ .next
ADC #$10 : STA $57
.next:
REP #$20
LDA $09DA : BIT #$0003 : BEQ carryclear
SEP #$20
LDA $51 : AND #$0F : BEQ carryset
DEC : STA $51

carryclear:
PLP : CLC : RTS
carryset:
PLP : SEC : RTS


FadeIn: ; fades the screen back in and decreases mosaic effect, returns carry clear if still busy, carry set if done
PHP : SEP #$20
LDA $57 : CMP #$0F : BEQ .next
SBC #$10 : STA $57
.next:
LDA $51 : INC : STA $51 : CMP #$0F : BEQ carryset
BRA carryclear

Loadstartmosaic: ; loads minimal mosaic settings (basically none, but we tell it to affect all BG layers)
PHP : SEP #$20
LDA #$0F : STA $57
PLP : RTS

Loadfullmosaic: ; loads full max mosaic settings
PHP : SEP #$20
LDA #$FF : STA $57
PLP : RTS


cutscenInst:
DW $87E5,$0140
DL !Textfreespace
DW $6D00
print "sleep: ",pc
instlist:
DW $86B4




;-------------------------------------------
;-------Vanilla hijacks---------------------
org $82E72F ;when loading room, check if need to set brightness or not
JSR checkifcutscene
RTS

org $82E75A ; check if need to play spinjumping or not
JSR checkifsound : NOP

org $82854B ;if demo, do different stuff if it's a cutscene demo
JMP checkdemo

org $82855A;do different stuff with the timer as well
DEC $1F53

org $82853E ; when loading demo, check if need to set brightness or not
JSR checkifcutscene
PLP : RTS

org $8286F6 ;don't set/clear a bunch of sram if it's a cutscene demo
JSR Sramcheck
BNE dontclearsram : NOP 


org $828757
dontclearsram:

;-----------------------------
;------Freespace code---------
org !Bank82freespace ; if cutscene is active, don't set brightness to max, set to zero instead (set to zero is only needed for demo cutscenes, but we do it in both cases anyways)
checkifcutscene:
LDA !Cutsceneflag : BNE +
LDA $51 : ORA #$001F : STA $51 ; vanilla
RTS
+:
SEP #$20 : STZ $51 : REP #$20;set brightness to zero
RTS

checkifsound:
LDA !Cutsceneflag : BNE + ; if cutscene, don't play spinjumping sfx when going through door
JSL $848270
+
RTS

checkdemo: ; if not a demo cutscene, then use vanilla demo routine
JSR $8B44
LDA !Cutsceneflag : BNE cutscenedemo
JMP $854E ; go back to vanilla

cutscenedemo: ; if a demo, decrement timer, and if timer is zero, set game state back to gameplay
DEC $1F53
BNE +
LDA #$0008 : STA $0998
+:
PLP : RTS

Sramcheck: ; if a cutscene demo, don't reset a bunch of Sram stuff
INC $1F57
LDA !Cutsceneflag : BNE isdemo
LDX #$0000
RTS
isdemo:
LDA #$0001
RTS


org !Textfreespace
INCBIN "text.bin"



org $B4F4C0
message:
DW $0012
DB $B8,$01,$FC,$D0,$30
DB $C0,$01,$FC,$D1,$30
DB $C8,$01,$FC,$D2,$30
DB $D0,$01,$FC,$D3,$30
DB $D8,$01,$FC,$D3,$30
DB $E8,$01,$FC,$D9,$30
DB $00,$00,$FC,$D4,$30
DB $18,$00,$FC,$D9,$30
DB $28,$00,$FC,$D5,$30
DB $30,$00,$FC,$D6,$30
DB $40,$00,$FC,$D3,$30
DB $48,$00,$FC,$D7,$30
DB $50,$00,$FC,$D8,$30
DB $58,$00,$FC,$D0,$30
DB $F0,$01,$FC,$D3,$30
DB $F8,$01,$FC,$D5,$30
DB $08,$00,$FC,$D1,$30
DB $10,$00,$FC,$D5,$30


;---All the below rewrite the item drop routines for every boss, so the item drops get spawned inside of samus
; this is because otherwise you lose all the drops bc cutscenes delete them.
; so if there are bosses where you don't want this, just uncomment/remove it before applying the patch.

