;NOTE, this is from OmegaDragnet9's personal projects.

;This patch gives you a universal ammo system like the one in hyper metroid. Made by Tundain
; Important, edit the tile $5C in the HUD GFX, bc that tile will be used as a symbol between the current ammo and max ammo (a slash for example)
;and you can use the tiles $58,$59,$5A,$5B to write the word "ammo"
;don't forget to credit!
lorom

;these values are how much ammo it will consume when fired, and how much will be returned when picking up enemy drops
!supermissileweight = #$0005
!PowerbombWeight = #$0005
;these values are how much a plm of it's kind will add to the max ammo count
!supercount = #$000A
!powerbombcount = #$0014

!SBAcost = #$000A ; how much ammo sba's will consume
!crystalflashcost = #$001E ;how much ammo a full crystal flash consumes
!cystalflashtimer = #$0007 ;this has to do with how long it takes between each time health is restored
;lower values and higher values will shorten the delay, but generally you wouldn't want crystal flash to be slow so that's fine
!healthgiven = #$0019;how much energy each time (don't use #$19, it gives strange behaviour)

;FREESPACE!
!Bank80freespace = $80D180 ;repoint this to freespace in bank $80
!Bank84Freespace = $84F500 ;repoint to freespace in bank $84
!Bank90freespace = $90F700 ;repoint to freespace in bank $90

;---placing the missile counter at the right spot---
org $809B09
  LDX #$009C
org $809C10
  LDX #$009C
 ;----------------------

; making the hud initiation only do the missile counter and skip the other ones
org $809B0C
  JSR hijacked
  BRA Inithighlight
; same thing but for the constant hud processing routine
org $809C13
  JSR hijacked
  BRA handlehighlighter
  
;labels for the branches
org $809B2B
Inithighlight:
org $809C55
handlehighlighter:

; this makes displays the current amount and max amount counter
org !Bank80freespace
hijacked:
  JSR $9D78
  LDA $09C8
  LDX #$00A4
  JSR $9D78
  RTS
  
org $8489D2 ; super missiles plms affect missile count
  LDA $09C8
  CLC
  ADC $0000,y
  STA $09C8
  LDA $09C6
  CLC
  ADC $0000,y
  JSR updatesupers
  
org $8489FB ; pbs affect missile count
  LDA $09C8
  CLC
  ADC $0000,y
  STA $09C8
  LDA $09C6
  CLC
  ADC $0000,y
  JSR updatepbs
  
org !Bank84Freespace; this is just so the game knows if you have collected supers or pbs, could be done a bit more efficiently probably, but meh, it works
updatesupers:
  STA $09C6
  INC $09CC
  RTS
updatepbs:
  STA $09C6
  INC $09D0
  RTS
  
  
org $90C564 ;HUD selection for super missiles checks missiles instead
  JSR checkifcanselectsupers
  
;label
org $90C56B
cantshoot:

org $90BE91; firing ability check regular missiles instead
  LDA $09C6
org $90BEC4 ; decreases you regular ammo count instead
  JSR substractsupermissiles
org $90BF3C
  JSR checkifnotenoughsupers

  
  
org $90C577 ;HUD selection for pbs checks missiles instead
  JSR checkifcanselectpbs
org $90C0A1; firing ability check regular missiles instead
  JSR checkifnotenoughpbs
org $90C028
  LDA $09C6

org $90C02D
  JSR decreasepbs
  NOP
  NOP
  NOP
  
;SBA stuff
org $90CC21 ; cost of ammo for SBA's
DW #$0000,!SBAcost,!SBAcost,#$0000,!SBAcost,#$0000,#$0000,#$0000,!SBAcost,#$0000,#$0000,#$0000
 
org $90CCD2 ;firing sba's decrease universal ammo
  LDA $09C6
  SEC
  SBC $CC21,x
  BPL $03
  LDA #$0000
  STA $09C6
  JSR ($CCF0,x)
  JSR checkSBA
  
;Crystal flash stuff
org $90D64B
  LDA !crystalflashcost
org $90D6E3 ;hijack missile routine to skip and immediately  enter pb routine
  JMP crystalpbs
;label
org $90D729
crystalpbs:

org $90D731 ;make pb decrement decremnt missiles instead
  DEC $09C6
org $90D5D5 ;check if enough ammo to initiate crystal flash
  CMP !crystalflashcost
org $90D5DD; checks if you have 0 supers
  CMP #$0000
  
org $90D5E5;checks if you have 0 pbs
  CMP #$0000
org $90D72C
  BIT !cystalflashtimer
org $90D734
  LDA !healthgiven
  
 ; routines to decrement your ammo by different amounts based off the projectile fired
org !Bank90freespace
substractsupermissiles:
  LDA $09C6
  SBC !supermissileweight
  STA $09C6
  RTS
decreasepbs:
  LDA $09C6
  SBC !PowerbombWeight
  STA $09C6
  RTS
 ;routines to check if you can select supers based of if 1: you have more then 0 max supers, and 2: you have enough ammo to fire a super
checkifcanselectsupers:
  LDA $09CC
  BEQ itcantshoot
  LDA $09C6
  CMP !supermissileweight
  BMI itcantshoot
  LDA $09C6
  RTS
itcantshoot:
  LDA #$0000
  RTS
checkifnotenoughsupers:
  LDA $09C6
  CMP !supermissileweight
  BMI itcantshoot
  LDA $09C6
  RTS
 ; same things but for pbs
checkifcanselectpbs:
  LDA $09D0
  BEQ itcantshoot
  LDA $09C6
  CMP !PowerbombWeight
  BMI itcantshoot
  LDA $09C6
  RTS

checkifnotenoughpbs:
  LDA $09C6
  CMP !PowerbombWeight
  BMI itcantshoot
  LDA $09C6
  RTS
  
checkSBA:
  LDA $09C6
  CMP !SBAcost
  BMI cannotSBA
  LDA $09C6
  RTS
cannotSBA:
  LDA #$0000
  RTS



;hud tilemap for writing the word "ammo" and the slash symbol
org $8098CB
DW #$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C12,#$2C12,#$2C23,#$2C12,#$2C12,#$2C1E
DW #$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2822,#$2822,#$2823,#$2813,#$2C14,#$2C1E
DW #$2C0F,#$2C0B,#$2C0C,#$2C0D,#$2C32,#$2C0F,#$2C09,#$2C0F,#$2C0F,#$2C0F,#$2C58,#$2C59,#$2C5A,#$2C5B,#$2C0F,#$2C0F,#$2C0F,#$2C5C,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C0F,#$2C12,#$2C12,#$A824,#$2815,#$2C16,#$2C1E


;plms give variable ammo
org $84E102 ; normal version
DW !supercount
org $84E4D8; chozo orb version
DW !supercount
org $84E9AF ;hidden version
DW !supercount

;powerbombs
org $84E127
DW !powerbombcount;normal version
org $84E50A;chozo orb version
DW !powerbombcount
org $84E9E7;hidden version
DW !powerbombcount

;making item drops give you universal ammo
org $86F0F7
  LDA !supermissileweight
org $91DFDA
  ADC $09C6
  STA $09C6
  CMP $09C8
  BMI $08
  BEQ $06
  LDA $09C8
  STA $09C6
  
org $86F0D9
  LDA !PowerbombWeight
org $91DFF7
  ADC $09C6
  STA $09C6
  CMP $09C8
  BMI $08
  BEQ $06
  LDA $09C8
  STA $09C6
  
org $86F1B1 ;makes enemies be able to drop other stuff than missiles
  LDY $09C6
  CPY $09C8
org $86F1C8
  LDY $09C6
  CPY $09C8
  
  ;NOTES, Newer revisions have this fix.
  
org $A2AADF

NOP #16
  
  
  
  
  