;K: A hack to add new message boxes. Based on an item in Insanity, stripped of spoily stuff and commented for public use.
;K: This hasn't been extensively bugtested yet, but at the moment I don't know of any bugs from it.
;J: I've tested it. Looks like, you can use big and small messages with or without highlighted buttons.
;J: Lines below are used to set letter and color numbers for using in this patch.

;N: YOU SHOULD DEFINITELY READ THIS WHOLE DOCUMENT BEFORE USING IT.
;N: Everything in a line after a semicolon (like this line here) is COMMENTED OUT. It is NOT CODE, but rather notes to help you understand what's going on here. You're going to need them.
;N: Troubleshooting problems? Maybe this will help: http://forum.metroidconstruction.com/index.php/topic,3612.msg47748.html
;N: and this: http://forum.metroidconstruction.com/index.php/topic,4449.msg60545.html#msg60545
;N: and this: http://forum.metroidconstruction.com/index.php/topic,735.0.html

;lorom

;Letters
!A = $E0
!B = $E1
!C = $E2
!D = $E3
!E = $E4
!F = $E5
!G = $E6
!H = $E7
!I = $E8
!J = $E9
!K = $EA
!L = $EB
!M = $EC
!N = $ED
!O = $EE
!P = $EF
!Q = $F0
!R = $F1
!S = $F2
!T = $F3
!U = $F4
!V = $F5
!W = $F6
!X = $F7
!Y = $F8
!Z = $F9

;Numbers
!n1 = $00	;1
!n2 = $01	;2
!n3 = $02	;3
!n4 = $03	;4
!n5 = $04	;5
!n6 = $05	;6
!n7 = $06	;7
!n8 = $07	;8
!n9 = $08	;9
!n0 = $09	;0

;Symbols
!dot = $FA	; .
!comma = $FB	; ,
!quotestart = $FC	; `
!quoteend = $FC	; '
!question = $FE	; ?
!exclamation = $FF	; !
!- = $CF		; -
!percent = $0A	; %
!_ = $4E		; empty

;Colors
!red = $28
!yellow = $3C
!green = $38
!blue = $2C

;MessageConstants
!Big = #$825A
!Small = #$8289
!EmptySmall = #$8436
!Shot = #$83C5
!Dash = #$83CC
!Jump = #$8756
!ItemCancel = #$875D
!ItemSelect = #$8764
!AimDown = #$876B
!AimUp = #$8773
!EmptyBig = #$877A




;header	
;K: Uncomment this if you're using a headered ROM
;J: Hint: commented lines are starting from ";" and they aren't executed.

lorom


;K: Somewhere in your bank 84 you should have a PLM using a message box, change the index to 1D or higher.
;K: See PLM_Details.txt for how to do that.
;J: You can create new item or use Messenger patch (see patch section) for this purpose.

;	DW $88F3 : DW $0040 : DB $1D	;For example, this is the instruction used by a new item in Insanity.


org $859643

;K: Here is where you can put in new message box entries and tiles. All entries must be consecutive; do not put tiles in between entries.

;K: Example message box entries. They start at the first new slot, 1D.
;K: The first two DW's are for the message box setup and size. This is a simple, 3-high message box with 1 line of text. Other options are possible (see the table at 85869B if you want) but I haven't documented any and the code at the bottom only supports this option.
;J: Alright, I did it. The only thing I don't know is how to get 3 line text messages, such as "Energy recharge completed."

;K: Each new entry simply needs a new message box name for the last DW.
;J: For the big messages, use any of these constants, depending on button you need for the first DW: !Shot, !Dash, !Jump, !ItemCancel, !ItemSelect, !AimDown, !AimUp.
;J: To get a big message without rewriting certain tile use !EmptyBig constant.
;J: Second DW should be !Big for a big messages.

;J: For the small messages, use !EmptySmall for the first DW and !Small for the second one.

;N: Below this line are examples. You can either uncomment one or copy one and make your own. These correspond to the example message boxes below (which are also currently commented out). See below for more details.

;	DW !Shot, !Big, BigMessageBoxShot
;	DW !Dash, !Big, BigMessageBoxDash
;	DW !EmptySmall, !Small, SmallMessageBox
	DW !EmptyBig, !Big, SpiderballMessage

;J: Don't touch this line. Meaning of it is that game can't display the last message in the array correctly, even if is a pointer is leading to unexisting message. FixSize subroutine in the Kej's code allows to use only small message box as last one (see below).
	DW !EmptySmall, !Small, ButtonArray



;K: Small message box tiles. Start with the message box name from its entry.
;K&J: The first and last lines are blank tiles for past the left and right edge of the message box. These must be in every message box, and you probably don't want to change them.
;K&J: The lines starting with DB you'll probably want to edit. 
;J: In each line starting with DB there should be a letter and a color after that. Don't place 2 letters or 2 colors in one line!
;J: Change "_" symbol after sign "!" to get the letter you want. 
;J: Change color after sign "!" to change color. Available colors are: red, yellow, green and blue.
;K&J: Each small message box requires 32 words, so don't add or delete any lines, just change them.

;N: Below this line is an example. You can either uncomment it or copy it and make your own. MAKE SURE the title of this (for this example, it's "SmallMessageBox") also has a corresponding line above (for this example, it's line 116: 	DW !EmptySmall, !Small, SmallMessageBox)

;SmallMessageBox:
;	DW $000E, $000E, $000E, $000E, $000E, $000E
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !T, !red
;	DB !E, !red
;	DB !S, !red
;	DB !T, !red
;	DB !n1, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DW $000E, $000E, $000E, $000E, $000E, $000E, $000E

SpiderballMessage:
DW $000E, $000E, $000E, $284E, $284E, $284E, $284E, $284E, $284E, $284E, $284E, $28F2, $28EF, $28E8, $28E3, $28E4, $28F1, $28E1, $28E0, $28EB, $28EB, $284E, $284E, $284E, $284E, $284E, $284E, $284E, $284E, $000E, $000E, $000E
DW $000E, $000E, $000E, $284E, $284E, $284E, $284E, $38DC, $284E, $284E, $284E, $284E, $284E, $284E, $284E, $284E, $284E, $284E, $284E, $284E, $284E, $284E, $284E, $284E, $284E, $284E, $284E, $284E, $284E, $000E, $000E, $000E
DW $000E, $000E, $000E, $284E, $284E, $284E, $284E, $3CDD, $3CDF, $284E, $284E, $284E, $284E, $284E, $284E, $284E, $284E, $284E, $284E, $284E, $284E, $284E, $284E, $284E, $284E, $284E, $284E, $284E, $284E, $000E, $000E, $000E
DW $000E, $000E, $000E, $284E, $284E, $284E, $284E, $3CDE, $3CCC, $38CD, $3CC9, $284E, $28C8, $284E, $28B3, $28B4, $28C0, $28C1, $28D1, $38F1, $28D3, $28B5, $28B6, $28B7, $28CB, $284E, $284E, $284E, $284E, $000E, $000E, $000E











;J: Big message box tiles. Start with the message box name from its entry.
;K&J: The first and last lines in each group are blank tiles for past the left and right edge of the message box. These must be in every message box, and you probably don't want to change them.
;K&J: The lines starting with DB you'll probably want to edit. 
;J: In each line starting with DB there should be a letter and a color after that. Don't place 2 letters or 2 colors in one line!
;J: Change "_" symbol after sign "!" to get the letter you want. 
;J: Change color after sign "!" to change color. Available colors are: red, yellow, green and blue.
;K&J: Each big message box requires 128 words (4 groups of 32 words), so don't add or delete any lines, just change them.

;N: Below this line are two examples. It works pretty much the same as the small ones, but it's big. Remember that each big message box is 4 blocks long (you can tell when one ends and the next starts by where the name for the next message box is; in these examples, BigMessageBoxShot ends where BigMessageBoxDash begins).



;BigMessageBoxShot:
;	DW $000E, $000E, $000E
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !T, !red
;	DB !E, !red
;	DB !S, !red
;	DB !T, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DW $000E, $000E, $000E

;	DW $000E, $000E, $000E
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !T, !red
;	DB !E, !red
;	DB !S, !red
;	DB !T, !red
;	DB !n2, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DW $000E, $000E, $000E

;	DW $000E, $000E, $000E
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !T, !red
;	DB !E, !red
;	DB !S, !red
;	DB !T, !red
;	DB !n3, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DW $000E, $000E, $000E

;	DW $000E, $000E, $000E
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !T, !red
;	DB !E, !red
;	DB !S, !red
;	DB !T, !red
;	DB !n4, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DW $000E, $000E, $000E




;BigMessageBoxDash:
;	DW $000E, $000E, $000E
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !T, !red
;	DB !E, !red
;	DB !S, !red
;	DB !T, !red
;	DB !n1, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DW $000E, $000E, $000E

;	DW $000E, $000E, $000E
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !T, !red
;	DB !E, !red
;	DB !S, !red
;	DB !T, !red
;	DB !n2, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DW $000E, $000E, $000E

;	DW $000E, $000E, $000E
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !T, !red
;	DB !E, !red
;	DB !S, !red
;	DB !T, !red
;	DB !n3, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DW $000E, $000E, $000E

;	DW $000E, $000E, $000E
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !T, !red
;	DB !E, !red
;	DB !S, !red
;	DB !T, !red
;	DB !n4, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DB !_, !red
;	DW $000E, $000E, $000E


;J: Strict order like "small messages first" isn't necessary. 

;==========================================================================

;J: There is a relocated button array for big messages with text "press certain button". 
;J: Meaning of this array is if you change default control settings and shot will use Y button instead of X, then in the default text (press the X button) letter X will be rewritten with Y. 
;J: Actually, there are a different button written by default in each message, but this doesn't matter.

;J: Each word is a position of correct letter. 
;J: When adding a new message, don't forget to add a word to this array. 

;J: In short messages such as "Energy Tank" the value must be $0000.

;J: In big messages the value is the position of tile that will be rewritten.
;J: Add 2 to move the button right, subtract 2 to move the button left.
;J: Add 40 to move the button down, subtract 40 to move the button up.
;J: To create big message without rewriting a tile, use value $0020 and !EmptyBig constant as a first DW when defining certain message box.
;J: Note that you can overwrite empty tiles in top and border lines of each message.


ButtonArray:
	DW $0000, $012A, $012A, $012C, $012C, $012C, $0000, $0000, $0000, $0000, $0000, $0000, $0120, $0000, $0000
;Above: Messages 01-0F (Don't touch)
;N: When adding new messages, you'll have to add an entry to the below line. See above for details.
	DW $0000, $0000, $0000, $012A, $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
;Above: Messages 10-1C
	DW $0000
;Above: SpiderballMessage





;K: The rest is code to make the game use the free space above for new message boxes. No touching.
;K: If you do intend to try something tricky, please note that this code is placed at the end of the above message boxes and doesn't have its own org.
;J: FixSize subroutine is replaced. It has a limitation for using only small messages. I've tweaked it a bit, but got another limitation: last message must be small. So, I got rid of it and added a bunch of pointers to unexisting message (see above).

;J: Fix1C1F subroutine is relocated to use space previously used by button array.

org $858749
Fix1C1F:
	LDA $1C1F
	CMP #$001D
	BPL +
	RTS
+
	ADC #$027F
	RTS

;J: Extra code, allowing to use all buttons, not only used Run and Fire used by game for creating messages like "press A to jump" (and get correct button, of course) or short instructions of how to use Wall Jump or Space Jump techniques. You can also make a short player-friendly guide for each button and display these messages in the first few rooms, like it was done in Metroid Prime series.


;Jump
	REP #30
	LDA $09B4
	BRA $1A
;ItemCancel
	REP #30
	LDA $09B8
	BRA $13
;ItemSelect
	REP #30
	LDA $09BA
	BRA $0C
;AimDown
	REP #30
	LDA $09BC
	BRA $05
;AimUp
	REP #30
	LDA $09BE
	JMP $83D1
;EmptyBig
	REP #30
	JMP $8409

org $858243
	JSR Fix1C1F

org $8582E5
	JSR Fix1C1F

org $858413
	DW ButtonArray

;K: Kejardon
;J: JAM
;N: Nodever2
;Version 4